## svxlink 15.11

=== src/CMakeLists.txt ===
##############################################################################
# SvxLink - A Multi Purpose Voice Services System for Ham Radio Use
# Copyright (C) 2003-2013 Tobias Blomberg / SM0SVX
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##############################################################################

##############################################################################
# Project setup
##############################################################################
cmake_minimum_required(VERSION 2.8)
project(svxlink C CXX)
#enable_testing()

# The path to the project global include directory
set(PROJECT_INCLUDE_DIR ${PROJECT_BINARY_DIR}/include)

# Where to put library files
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)

# Where to put executable files
set(RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)

# Add project local CMake module directory
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Optional parts
option(USE_QT "Build Qt applications and libs" ON)
option(BUILD_STATIC_LIBS "Build static libraries in addition to dynamic" OFF)

# The sample rate used internally in SvxLink
if(NOT DEFINED INTERNAL_SAMPLE_RATE)
  set(INTERNAL_SAMPLE_RATE 16000)
endif(NOT DEFINED INTERNAL_SAMPLE_RATE)
add_definitions(-DINTERNAL_SAMPLE_RATE=${INTERNAL_SAMPLE_RATE})

# Set up include directories
include_directories(
  ${PROJECT_INCLUDE_DIR}
  ${CMAKE_BINARY_DIR}
)

# Warnings should be enabled for GCC. Also turning off the NDEBUG flag
# since that remove asserts.
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_C_FLAGS
    "${CMAKE_C_FLAGS} -Wall -Wstrict-prototypes -Wpointer-arith")
  set(CMAKE_C_FLAGS_RELEASE "-O3")
  set(CMAKE_C_FLAGS_RELWITHDEBINFO "-O2 -g")

  set(CMAKE_CXX_FLAGS
    "${CMAKE_CXX_FLAGS} -Wall -Wpointer-arith")
  set(CMAKE_CXX_FLAGS_RELEASE "-O3")
  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O2 -g")
endif()

# Set the default build type to Release
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
      "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif(NOT CMAKE_BUILD_TYPE)


##############################################################################
# Install targets properties setup
##############################################################################

# Set up standard GNU installation directories
include(GNUInstallDirs)

# Where to install include files
if(NOT DEFINED INCLUDE_INSTALL_DIR)
  #set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/include)
  set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR})
endif(NOT DEFINED INCLUDE_INSTALL_DIR)

# Where to install libraries
if(NOT DEFINED LIB_INSTALL_DIR)
  #set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
  set(LIB_INSTALL_DIR ${CMAKE_INSTALL_FULL_LIBDIR})
endif(NOT DEFINED LIB_INSTALL_DIR)

# The config directory (normally /etc)
if(NOT DEFINED SYSCONF_INSTALL_DIR)
  #set(SYSCONF_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/etc)
  set(SYSCONF_INSTALL_DIR ${CMAKE_INSTALL_FULL_SYSCONFDIR})
endif(NOT DEFINED SYSCONF_INSTALL_DIR)

# Architecture independent files directory (normally /usr/share)
if(NOT DEFINED SHARE_INSTALL_PREFIX)
  #set(SHARE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}/share)
  set(SHARE_INSTALL_PREFIX ${CMAKE_INSTALL_FULL_DATADIR})
endif(NOT DEFINED SHARE_INSTALL_PREFIX)

# Local state directory (normally /var)
if(NOT DEFINED LOCAL_STATE_DIR)
  #set(LOCAL_STATE_DIR ${CMAKE_INSTALL_PREFIX}/var)
  set(LOCAL_STATE_DIR ${CMAKE_INSTALL_FULL_LOCALSTATEDIR})
endif(NOT DEFINED LOCAL_STATE_DIR)

# Where to install executables
if(NOT DEFINED BIN_INSTALL_DIR)
  #set(BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin)
  set(BIN_INSTALL_DIR ${CMAKE_INSTALL_FULL_BINDIR})
endif(NOT DEFINED BIN_INSTALL_DIR)

# Where to install manual pages
if(NOT DEFINED MAN_INSTALL_DIR)
  #set(MAN_INSTALL_DIR ${SHARE_INSTALL_PREFIX}/man)
  set(MAN_INSTALL_DIR ${CMAKE_INSTALL_FULL_MANDIR})
endif(NOT DEFINED MAN_INSTALL_DIR)

# Where to install documentation
if(NOT DEFINED DOC_INSTALL_DIR)
  #set(DOC_INSTALL_DIR ${SHARE_INSTALL_PREFIX}/doc/svxlink)
  set(DOC_INSTALL_DIR ${CMAKE_INSTALL_FULL_DOCDIR})
endif(NOT DEFINED DOC_INSTALL_DIR)

# Where to install startup scripts
if(NOT DEFINED INIT_D_INSTALL_DIR)
  set(INIT_D_INSTALL_DIR ${SYSCONF_INSTALL_DIR}/init.d)
endif(NOT DEFINED INIT_D_INSTALL_DIR)

# Where to install SvxLink config files
if(NOT DEFINED SVX_SYSCONF_INSTALL_DIR)
  set(SVX_SYSCONF_INSTALL_DIR ${SYSCONF_INSTALL_DIR}/svxlink)
endif(NOT DEFINED SVX_SYSCONF_INSTALL_DIR)

# Where to install SvxLink spool files
if(NOT DEFINED SVX_SPOOL_INSTALL_DIR)
  set(SVX_SPOOL_INSTALL_DIR ${LOCAL_STATE_DIR}/spool/svxlink)
endif(NOT DEFINED SVX_SPOOL_INSTALL_DIR)

# Where to install SvxLink architecture independent files
if(NOT DEFINED SVX_SHARE_INSTALL_DIR)
  set(SVX_SHARE_INSTALL_DIR ${SHARE_INSTALL_PREFIX}/svxlink)
endif(NOT DEFINED SVX_SHARE_INSTALL_DIR)

# Where to install include files
if(NOT DEFINED SVX_INCLUDE_INSTALL_DIR)
  set(SVX_INCLUDE_INSTALL_DIR ${INCLUDE_INSTALL_DIR}/svxlink)
endif(NOT DEFINED SVX_INCLUDE_INSTALL_DIR)

# Where to install SvxLink modules
if(NOT DEFINED SVX_MODULE_INSTALL_DIR)
  set(SVX_MODULE_INSTALL_DIR ${LIB_INSTALL_DIR}/svxlink)
endif(NOT DEFINED SVX_MODULE_INSTALL_DIR)


##############################################################################
# Functions
##############################################################################

# Create an include file under the global include directory
function(expinc filename)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${filename}
    ${PROJECT_INCLUDE_DIR}/${filename}
    COPYONLY
    )
endfunction(expinc)

# Add a target for building a version/xyz.h file
#
#   add_version_target(name [depends_var])
#
# The name of the version variable should be VER_name and the versions file
# will be named versions/name.h.
# If depends_var is given it will be set to a list of dependencies that the
# target using the versions file should add to its dependency list.
function(add_version_target name)
  set(depends_var ${ARGV1})
  if(DEFINED depends_var)
    set(${depends_var} ${${depends_var}}
      "${PROJECT_INCLUDE_DIR}/version/${name}.h"
      PARENT_SCOPE
      )
  endif(DEFINED depends_var)

  if(VER_${name})
    set(VERSION ${VER_${name}})
  else(VER_${name})
    set(VERSION "?.?.?")
  endif(VER_${name})

  add_custom_command(
    OUTPUT ${PROJECT_INCLUDE_DIR}/version/${name}.h
    WORKING_DIRECTORY ${PROJECT_INCLUDE_DIR}
    COMMAND ${CMAKE_COMMAND} -DVER_NAME=${name} -DVER_VALUE=${VERSION} 
                     -P ${CMAKE_SOURCE_DIR}/cmake/create_version_include.cmake
    DEPENDS ${CMAKE_SOURCE_DIR}/versions
            ${CMAKE_SOURCE_DIR}/cmake/create_version_include.cmake
  )
endfunction(add_version_target)

# Read a versions file and set up CMake variables for each entry
function(read_versions_file filename)
  message(STATUS "Reading versions file...")
  file(STRINGS ${filename} versions REGEX .*=.*)
  foreach(version ${versions})
    string(REGEX REPLACE \(.*\)=\(.*\) "VER_\\1;\\2" version ${version})
    set(${version} PARENT_SCOPE)
    if(version MATCHES ^VER_LIB)
      list(GET version 0 varname)
      list(GET version 1 varvalue)
      string(REGEX MATCH [0-9]+\\.[0-9]+ ${varname}_SOVERSION ${varvalue})
      set(${varname}_SOVERSION ${${varname}_SOVERSION} PARENT_SCOPE)
    endif(version MATCHES ^VER_LIB)
  endforeach(version)
endfunction(read_versions_file)

# Create a post install target to change the owner of an installed file.
# If DO_INSTALL_CHOWN is set to YES, the owner will be changed during
# installation.
# If DO_INSTALL_CHOWN is unset, the DESTDIR environment variable will be
# examined. If it is set, no chown operations will be performed since we are
# probably not running as a user with administrative rights. If DESTDIR is
# unset, chown operations are performed.
function(install_chown filename owner)
  if(owner)
    set(chown_commands "
      set(CHOWN_TOOL ${CHOWN_TOOL})
      if(NOT CHOWN_TOOL)
        MESSAGE(FATAL_ERROR \"Unable to find the 'chown' utility\")
      endif(NOT CHOWN_TOOL)
      set(full_filename \"\$ENV{DESTDIR}${filename}\")
      message(STATUS \"Setting owner of \${full_filename} to ${owner}...\")
      execute_process(
        COMMAND ${CHOWN_TOOL} ${owner} \"\${full_filename}\"
        RESULT_VARIABLE cmd_result
        )
      if(NOT \${cmd_result} EQUAL 0)
        MESSAGE(FATAL_ERROR
          \"Error while changing owner of file \${full_filename}\"
          )
      endif(NOT \${cmd_result} EQUAL 0)
      ")
    if(DEFINED DO_INSTALL_CHOWN)
      if(DO_INSTALL_CHOWN)
        install(CODE "${chown_commands}")
      endif(DO_INSTALL_CHOWN)
    else(DEFINED DO_INSTALL_CHOWN)
      install(CODE "
        if(\"\$ENV{DESTDIR}\" STREQUAL \"\")
          ${chown_commands}
        endif(\"\$ENV{DESTDIR}\" STREQUAL \"\")
        ")
    endif(DEFINED DO_INSTALL_CHOWN)
  endif(owner)
endfunction(install_chown)

# Create the given directory during installation
#   install_mkdir(directory [owner])
function(install_mkdir dir)
  set(owner ${ARGV1})
  get_filename_component(parent ${dir} PATH)
  file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}${dir})
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}${dir} DESTINATION ${parent})
  install_chown(${dir} "${owner}")
endfunction(install_mkdir)

# Before installing the file, check if it exists. If it does, don't
# overwrite it.
#   install_if_not_exists(source_file destination_directory)
function(install_if_not_exists src dest)
  if(NOT IS_ABSOLUTE "${src}")
    set(src "${CMAKE_CURRENT_SOURCE_DIR}/${src}")
  endif()
  get_filename_component(src_name "${src}" NAME)
  if (NOT IS_ABSOLUTE "${dest}")
    set(dest "${CMAKE_INSTALL_PREFIX}/${dest}")
  endif()
  install(CODE "
    if(NOT EXISTS \"\$ENV{DESTDIR}${dest}/${src_name}\")
      #file(INSTALL \"${src}\" DESTINATION \"${dest}\")
      message(STATUS \"Installing: \$ENV{DESTDIR}${dest}/${src_name}\")
      execute_process(COMMAND \${CMAKE_COMMAND} -E copy \"${src}\"
                      \"\$ENV{DESTDIR}${dest}/${src_name}\"
                      RESULT_VARIABLE copy_result
                      ERROR_VARIABLE error_output)
      if(copy_result)
        message(FATAL_ERROR \${error_output})
      endif()
    else()
      message(STATUS \"Skipping  : \$ENV{DESTDIR}${dest}/${src_name}\")
    endif()
  ")
endfunction(install_if_not_exists)


##############################################################################
# Main execution starts here
##############################################################################

# Load the versions file and define version variables
read_versions_file(${PROJECT_SOURCE_DIR}/versions)

configure_file(${CMAKE_SOURCE_DIR}/config.h.in
  ${CMAKE_BINARY_DIR}/config.h
  @ONLY
  )

# Find the Sigc++ library
find_package(SIGC2 REQUIRED)
include_directories(${SIGC2_INCLUDE_DIRS})
add_definitions(${SIGC2_DEFINITIONS})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SIGC2_CXX_FLAGS}")
set(LIBS ${LIBS} ${SIGC2_LIBRARIES})

# Find the chown utility
include(FindCHOWN)

# Add directories to build
add_subdirectory(async)
add_subdirectory(misc)
add_subdirectory(echolib)
add_subdirectory(locationinfo)
add_subdirectory(svxlink)
if(USE_QT)
  add_subdirectory(qtel)

=== src/misc/CMakeLists.txt ===
set(EXPINC common.h CppStdCompat.h)

# Copy exported include files to the global include directory
foreach(incfile ${EXPINC})
  expinc(${incfile})
endforeach(incfile)

# Install targets
install(FILES ${EXPINC} DESTINATION ${SVX_INCLUDE_INSTALL_DIR})

=== src/svxlink/CMakeLists.txt ===
include_directories(trx svxlink)

add_subdirectory(trx)
add_subdirectory(svxlink)
add_subdirectory(modules)
#add_subdirectory(scripts)
add_subdirectory(remotetrx)
add_subdirectory(siglevdetcal)
add_subdirectory(devcal)

=== src/async/core/CMakeLists.txt ===
set(LIBNAME asynccore)

set(EXPINC AsyncApplication.h AsyncFdWatch.h AsyncTimer.h AsyncIpAddress.h
           AsyncTcpClient.h AsyncDnsLookup.h AsyncUdpSocket.h AsyncTcpServer.h
           AsyncTcpConnection.h AsyncConfig.h AsyncSerial.h AsyncFileReader.h
           AsyncAtTimer.h AsyncExec.h AsyncPty.h AsyncPtyStreamBuf.h)

set(LIBSRC AsyncApplication.cpp AsyncFdWatch.cpp AsyncTimer.cpp
           AsyncIpAddress.cpp AsyncDnsLookup.cpp AsyncTcpClient.cpp
           AsyncUdpSocket.cpp AsyncTcpServer.cpp
           AsyncTcpConnection.cpp AsyncConfig.cpp AsyncSerial.cpp
           AsyncSerialDevice.cpp AsyncFileReader.cpp
           AsyncAtTimer.cpp AsyncExec.cpp AsyncPty.cpp AsyncPtyStreamBuf.cpp)

# Copy exported include files to the global include directory
foreach(incfile ${EXPINC})
  expinc(${incfile})
endforeach(incfile)

# Find pthreads
find_package(Threads)
set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})

# Set up additional defines
# FIXME: Do we need this?
add_definitions(-D_REENTRANT)

# Build a shared library and a static library if configured
add_library(${LIBNAME} SHARED ${LIBSRC})
set_target_properties(${LIBNAME} PROPERTIES VERSION ${VER_LIBASYNC}
                      SOVERSION ${VER_LIBASYNC_SOVERSION})
target_link_libraries(${LIBNAME} ${LIBS})
if (BUILD_STATIC_LIBS)
  add_library(${LIBNAME}_static STATIC ${LIBSRC})
  set_target_properties(${LIBNAME}_static PROPERTIES OUTPUT_NAME ${LIBNAME})
  target_link_libraries(${LIBNAME}_static ${LIBS})
endif(BUILD_STATIC_LIBS)

# Install files
install(TARGETS ${LIBNAME} DESTINATION ${LIB_INSTALL_DIR})
if (BUILD_STATIC_LIBS)
  install(TARGETS ${LIBNAME}_static DESTINATION ${LIB_INSTALL_DIR})
endif(BUILD_STATIC_LIBS)
install(FILES ${EXPINC} DESTINATION ${SVX_INCLUDE_INSTALL_DIR})

=== src/async/demo/CMakeLists.txt ===
set(CPPPROGS AsyncAudioIO_demo AsyncDnsLookup_demo AsyncFdWatch_demo
             AsyncTimer_demo AsyncTcpClient_demo AsyncUdpSocket_demo
             AsyncCppApplication_demo AsyncTcpServer_demo AsyncConfig_demo
             AsyncSerial_demo AsyncAtTimer_demo AsyncExec_demo
             AsyncPtyStreamBuf_demo)


foreach(prog ${CPPPROGS})
  add_executable(${prog} ${prog}.cpp)
  target_link_libraries(${prog} ${LIBS} asynccpp asyncaudio asynccore)
endforeach(prog)

if(USE_QT)
  # Find Qt4
  find_package(Qt4 4.2 REQUIRED QtCore QtGui QtNetwork)
  include(${QT_USE_FILE})
  set(LIBS ${LIBS} ${QT_LIBRARIES})
  #QT4_WRAP_CPP(QTHEADERS_MOC ${QTHEADERS})

  add_executable(AsyncQtApplication_demo AsyncQtApplication_demo.cpp)
  target_link_libraries(AsyncQtApplication_demo ${LIBS} asyncaudio
                        asynccore asyncqt)
endif(USE_QT)

=== src/doc/man/CMakeLists.txt ===
# Set up which man pages to build and install
set(MAN_PAGES svxlink.1 remotetrx.1 siglevdetcal.1 svxlink.conf.5
  ModuleHelp.conf.5 remotetrx.conf.5 ModuleParrot.conf.5 ModuleEchoLink.conf.5
  ModuleTclVoiceMail.conf.5 ModuleDtmfRepeater.conf.5
  ModulePropagationMonitor.conf.5 ModuleSelCallEnc.conf.5 qtel.1 devcal.1
)

# Search for the gzip and groff programs. Error out if not found.
include(FindGZIP)
include(FindGROFF)

# Set up a target for compressing each manual page. Also add an install
# target for it.
if(GROFF_TOOL AND GZIP_TOOL)
  set(TARGETS)
  foreach(man ${MAN_PAGES})
    add_custom_command(OUTPUT ${man}.gz
      DEPENDS ${man}
      COMMAND ${GZIP_TOOL} -c ${CMAKE_CURRENT_SOURCE_DIR}/${man} > ${man}.gz
      COMMENT "Compressing maual page ${man}.gz..."
    )
    add_custom_command(OUTPUT ${man}.html
      DEPENDS ${man}
      COMMAND ${GROFF_TOOL} -mandoc -Thtml < ${CMAKE_CURRENT_SOURCE_DIR}/${man} > ${man}.html
      COMMENT "Createing HTML maual page ${man}.html..."
    )
    string(REGEX REPLACE ^.*\([1-9]\)\$ \\1 sec ${man})
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${man}.gz
      DESTINATION ${MAN_INSTALL_DIR}/man${sec}
      OPTIONAL
    )
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${man}.html
      DESTINATION ${DOC_INSTALL_DIR}/man/man${sec}
      OPTIONAL
    )
    set(TARGETS ${TARGETS} ${man}.gz ${man}.html)
  endforeach(man)

  # Add a custom target to trigger the build of the man pages
  add_custom_target(man DEPENDS ${TARGETS})
  add_dependencies(doc man)
else(GROFF_TOOL AND GZIP_TOOL)
  message("--   The groff and gzip tools are optional dependencies.")
  message("--   They are used to build the UNIX manual pages. SvxLink will")
  message("--   build without them but usage documentation will be missing.")
endif(GROFF_TOOL AND GZIP_TOOL)

=== src/svxlink/devcal/CMakeLists.txt ===
# Find the popt library
find_package(Popt REQUIRED)
include_directories(${POPT_INCLUDE_DIRS})
add_definitions(${POPT_DEFINITIONS})

# Add targets for version files
set(VERSION_DEPENDS)
add_version_target(DEVCAL VERSION_DEPENDS)

add_executable(devcal devcal.cpp ${VERSION_DEPENDS})
target_link_libraries(devcal asyncaudio asynccpp trx ${POPT_LIBRARIES})
set_target_properties(devcal PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY ${RUNTIME_OUTPUT_DIRECTORY}
)

#add_executable(noisegen noisegen.cpp)
#target_link_libraries(noisegen asyncaudio asynccpp trx)
#set_target_properties(noisegen PROPERTIES
#  RUNTIME_OUTPUT_DIRECTORY ${RUNTIME_OUTPUT_DIRECTORY}
#)

=== src/svxlink/svxlink/CMakeLists.txt ===
# Find the popt library
find_package(Popt REQUIRED)
set(LIBS ${LIBS} ${POPT_LIBRARIES})
include_directories(${POPT_INCLUDE_DIRS})
add_definitions(${POPT_DEFINITIONS})

# Find the GSM codec library
find_package(GSM REQUIRED)
set(LIBS ${LIBS} ${GSM_LIBRARY})
include_directories(${GSM_INCLUDE_DIR})

# Find the TCL library
if(TCL_LIBRARY)
  set(TCL_LIBRARY_CACHED TRUE)
endif(TCL_LIBRARY)
find_package(TCL QUIET)
if(TCL_FOUND)
  if (NOT TCL_LIBRARY_CACHED)
    message("-- Found TCL: ${TCL_LIBRARY}")
  endif(NOT TCL_LIBRARY_CACHED)
else(TCL_FOUND)
  message(FATAL_ERROR "-- Could NOT find the TCL scripting language")
endif(TCL_FOUND)
set(LIBS ${LIBS} ${TCL_LIBRARY})
include_directories(${TCL_INCLUDE_PATH})

# Find the GCrypt library
find_package(GCrypt REQUIRED)
set(LIBS ${LIBS} ${GCRYPT_LIBRARIES})
include_directories(${GCRYPT_INCLUDE_DIRS})
add_definitions(${GCRYPT_DEFINITIONS})

# Find the dl library
find_package(DL REQUIRED)
set(LIBS ${LIBS} ${DL_LIBRARIES})
include_directories(${DL_INCLUDES})

# Add project libraries
set(LIBS ${LIBS} trx locationinfo asynccpp asyncaudio asynccore)

# Add targets for version files
set(VERSION_DEPENDS)
add_version_target(SVXLINK VERSION_DEPENDS)

# Build the executable
add_executable(svxlink
  MsgHandler.cpp Module.cpp Logic.cpp SimplexLogic.cpp RepeaterLogic.cpp
  EventHandler.cpp LinkManager.cpp CmdParser.cpp QsoRecorder.cpp svxlink.cpp
  DtmfDigitHandler.cpp
  ${VERSION_DEPENDS}
)
target_link_libraries(svxlink ${LIBS})
set_target_properties(svxlink PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY ${RUNTIME_OUTPUT_DIRECTORY}
)

# Generate config file with correct paths
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/svxlink.conf.in
  ${CMAKE_CURRENT_BINARY_DIR}/svxlink.conf
  @ONLY
  )

# Install targets
install(TARGETS svxlink DESTINATION ${BIN_INSTALL_DIR})
install_mkdir(${SVX_SYSCONF_INSTALL_DIR}/svxlink.d)
install_mkdir(${SVX_SPOOL_INSTALL_DIR}/qso_recorder svxlink.daemon)
install_mkdir(${SVX_SHARE_INSTALL_DIR}/sounds)
install_if_not_exists(${CMAKE_CURRENT_BINARY_DIR}/svxlink.conf
  ${SVX_SYSCONF_INSTALL_DIR}
  )
install(FILES events.tcl DESTINATION ${SVX_SHARE_INSTALL_DIR})
install(FILES RepeaterLogic.tcl SimplexLogic.tcl Module.tcl Logic.tcl CW.tcl
  SelCall.tcl locale.tcl
  DESTINATION ${SVX_SHARE_INSTALL_DIR}/events.d
  )

=== src/svxlink/modules/echolink/CMakeLists.txt ===
# The name of the module without the Module prefix
set(MODNAME EchoLink)

# Module source code
set(MODSRC QsoImpl.cpp)

# Project libraries to link to
set(LIBS ${LIBS} echolib)

# Find the TCL library
if(TCL_LIBRARY)
  set(TCL_LIBRARY_CACHED TRUE)
endif(TCL_LIBRARY)
find_package(TCL QUIET)
if(TCL_FOUND)
  if (NOT TCL_LIBRARY_CACHED)
    message("-- Found TCL: ${TCL_LIBRARY}")
  endif(NOT TCL_LIBRARY_CACHED)
else(TCL_FOUND)
  message(FATAL_ERROR "-- Could NOT find the TCL scripting language")
endif(TCL_FOUND)
set(LIBS ${LIBS} ${TCL_LIBRARY})
include_directories(${TCL_INCLUDE_PATH})

# Find the GSM codec library and include directory
find_package(GSM REQUIRED)
if(NOT GSM_FOUND)
  message(FATAL_ERROR "libgsm not found")
endif(NOT GSM_FOUND)
include_directories(${GSM_INCLUDE_DIR})
set(LIBS ${LIBS} ${GSM_LIBRARY})

string(TOUPPER MODULE_${MODNAME} VERNAME)

# Add targets for version files
set(VERSION_DEPENDS)
add_version_target(${VERNAME} VERSION_DEPENDS)
add_version_target(SVXLINK VERSION_DEPENDS)

# Build the plugin
add_library(Module${MODNAME} MODULE Module${MODNAME}.cpp ${MODSRC}
  ${VERSION_DEPENDS}
)
set_target_properties(Module${MODNAME} PROPERTIES PREFIX "")
target_link_libraries(Module${MODNAME} ${LIBS})

# Install targets
install(TARGETS Module${MODNAME} DESTINATION ${SVX_MODULE_INSTALL_DIR})
install(FILES ${MODNAME}.tcl DESTINATION ${SVX_SHARE_INSTALL_DIR}/events.d)
install_if_not_exists(Module${MODNAME}.conf
  ${SVX_SYSCONF_INSTALL_DIR}/svxlink.d
  )

=== debian/changelog ===
svxlink (15.11-1) unstable; urgency=medium

  [ Felix Lechner ]
  * New upstream release
  * Changed install locations to multiarch
  * Increased SONAMES to 1.4 for asyncaudio, asynccpp, asyncqt and asynccore

  [ Colin Tuckley ]
  * Bump Standards version to 3.9.7 (No changes required).

 -- Felix Lechner <felix.lechner@gmail.com>  Wed, 06 Apr 2016 09:26:50 +0100

=== debian/control ===
Source: svxlink
Section: hamradio
Priority: optional
Maintainer: Felix Lechner <felix.lechner@gmail.com>
Build-Depends: debhelper (>= 9), quilt, cmake,
 libsigc++-2.0-dev (>= 2.2.10-0.2), libpopt-dev, libgcrypt20-dev,
 libgsm1-dev, libspeex-dev, libopus-dev, libasound2-dev,
 qtbase5-dev, qttools5-dev, qttools5-dev-tools,
 tcl-dev, tk-dev,
 doxygen
Standards-Version: 3.9.7
Homepage: http://www.svxlink.org
Vcs-Browser: https://github.com/lechner/svxlink
Vcs-Git: https://github.com/lechner/svxlink.git

Package: svxlink-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Recommends: remotetrx (= ${binary:Version})
Description: Voice-over-IP server for ham radio operators
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 svxlink-server is normally used together with the 'remotetrx'
 package, which allows the remote control of a radio transceiver.
 .
 For a client program implementing the EchoLink® protocol, please
 have a look at the 'qtel' package.
 .
 This package contains the SvxLink server.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: svxlink-server-dbg
Architecture: any
Section: debug
Priority: extra
Depends: svxlink-server (= ${binary:Version}), ${misc:Depends}
Description: Voice-over-IP server for ham radio operators (debug symbols)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 SvxLink is normally used together with the 'remotetrx' package,
 which allows the remote control of a radio transceiver.
 .
 For a client program implementing the EchoLink® protocol, please
 have a look at the 'qtel' package.
 .
 This package contains the debug symbols for the SvxLink server.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: remotetrx
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Recommends: svxlink-server (= ${binary:Version})
Description: Remote controller for radio transceivers
 RemoteTrx facilitates remote control of ham radio transceivers via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The RemoteTrx server provides remote control of a connected radio
 transceiver.
 .
 RemoteTrx is normally used together with the 'svxlink-server'
 package, which allows for world-wide access via the Internet.
 .
 This package contains the RemoteTrx remote control server.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: remotetrx-dbg
Architecture: any
Section: debug
Priority: extra
Depends: remotetrx (= ${binary:Version}), ${misc:Depends}
Description: Remote controller for radio transceivers (debug symbols)
 RemoteTrx facilitates remote control of ham radio transceivers via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The RemoteTrx server provides remote control of a connected radio
 transceiver.
 .
 RemoteTrx would normally be used together with the 'svxlink-server'
 package, which allows for world-wide access via the Internet.
 .
 This package contains the debugging symbols for RemoteTrx.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: qtel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Graphical client for the EchoLink® protocol
 Qtel is a graphical client program for the EchoLink® ham radio
 protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 By connecting into a server connected to a repeater, an operator
 can call into a local radio net via the Internet while traveling
 out of the area.
 .
 This package contains the graphical client application Qtel.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: qtel-dbg
Architecture: any
Section: debug
Priority: extra
Depends: qtel (= ${binary:Version}), ${misc:Depends}
Description: Graphical client for the EchoLink® protocol (debug symbols)
 Qtel is a graphical client program for the EchoLink® ham radio
 protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 By connecting into a server connected to a repeater, an operator
 can call into a local radio net via the Internet while traveling
 out of the area.
 .
 This package contains the debugging symbols for Qtel.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasynccpp1.4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AsyncCpp library for SvxLink
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 This package contains the AsyncCpp library.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasynccpp-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends}, libasynccpp1.4 (= ${binary:Version})
Description: AsyncCpp library for SvxLink (debug symbols)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 This package contains the debug symbols for the AsyncCpp library.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasynccpp-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, libasynccpp1.4 (= ${binary:Version})
Description: AsyncCpp library for SvxLink (development files)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 This package contains the static version and the header files for the
 AsyncCpp library.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasyncaudio1.4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AsyncAudio library for SvxLink
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 This package contains the AsyncAudio library.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasyncaudio-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends}, libasyncaudio1.4 (= ${binary:Version})
Description: AsyncAudio library for SvxLink (debug symbols)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 This package contains the debug symbols for the AsyncAudio library.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasyncaudio-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, libasyncaudio1.4 (= ${binary:Version})
Description: AsyncAudio library for SvxLink (development files)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 This package contains the static version and the header files for the
 AsyncAudio library.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libecholib1.3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: EchoLib library for SvxLink
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 This package contains EchoLib, a library for EchoLink communications.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libecholib-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends}, libecholib1.3 (= ${binary:Version})
Description: EchoLib library for SvxLink (debug symbols)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 This package contains the debug symbols for the EchoLib library.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libecholib-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, libecholib1.3 (= ${binary:Version})
Description: EchoLib library for SvxLink (development files)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The server can act as a repeater controller or operate on a simplex
 channel. Based on a modular design, the server can be configured to
 provide voice mail and echo (talkback) service.
 .
 This package contains the static version and the header files for the
 EchoLib library.
 .
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasyncqt1.4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AsyncQt library for SvxLink
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.
 .

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export QT_SELECT=qt5

%:
	dh $@ \
		--parallel \
		--buildsystem=cmake \
		--sourcedirectory=src \
		--builddirectory=build \

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	find .. -name 'moc_*' -execdir rm -fv '{}' \;
	find .. -name 'qrc_*' -execdir rm -fv '{}' \;
	dh_auto_clean

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip -psvxlink-server --dbg-package=svxlink-server-dbg
	dh_strip -premotetrx --dbg-package=remotetrx-dbg
	dh_strip -pqtel --dbg-package=qtel-dbg
	dh_strip -plibecholib1.3 --dbg-package=libecholib-dbg
	dh_strip -plibasynccore1.4 --dbg-package=libasynccore-dbg
	dh_strip -plibasynccpp1.4 --dbg-package=libasynccpp-dbg
	dh_strip -plibasyncaudio1.4 --dbg-package=libasyncaudio-dbg
	dh_strip -plibasyncqt1.4 --dbg-package=libasyncqt-dbg

.PHONY: override_dh_install_init
override_dh_installinit:
	dh_installinit -psvxlink-server --name=svxlink
	dh_installinit -premotetrx

.PHONY: override_dh_installchangelogs
override_dh_installchangelogs:
	dh_installchangelogs -psvxlink-server src/svxlink/ChangeLog
	dh_installchangelogs -psvxlink-server-dbg src/svxlink/ChangeLog
	dh_installchangelogs -premotetrx src/svxlink/ChangeLog
	dh_installchangelogs -premotetrx-dbg src/svxlink/ChangeLog
	dh_installchangelogs -pqtel src/qtel/ChangeLog
	dh_installchangelogs -pqtel-dbg src/qtel/ChangeLog
	dh_installchangelogs -plibecholib1.3 src/echolib/ChangeLog
	dh_installchangelogs -plibecholib-dev src/echolib/ChangeLog
	dh_installchangelogs -plibecholib-dbg src/echolib/ChangeLog
	dh_installchangelogs -plibasynccore1.4 src/async/ChangeLog
	dh_installchangelogs -plibasynccore-dev src/async/ChangeLog
	dh_installchangelogs -plibasynccore-dbg src/async/ChangeLog
	dh_installchangelogs -plibasyncaudio1.4 src/async/ChangeLog
	dh_installchangelogs -plibasyncaudio-dev src/async/ChangeLog
	dh_installchangelogs -plibasyncaudio-dbg src/async/ChangeLog
	dh_installchangelogs -plibasynccpp1.4 src/async/ChangeLog
	dh_installchangelogs -plibasynccpp-dev src/async/ChangeLog
	dh_installchangelogs -plibasynccpp-dbg src/async/ChangeLog
	dh_installchangelogs -plibasyncqt1.4 src/async/ChangeLog
	dh_installchangelogs -plibasyncqt-dev src/async/ChangeLog
	dh_installchangelogs -plibasyncqt-dbg src/async/ChangeLog

#.PHONY: override_dh_fixperms
#override_dh_fixperms:
#	dh_fixperms
#	chmod a-x debian/svxlink-server/etc/default/svxlink
#	chmod a-x debian/remotetrx/etc/default/remotetrx

## svxlink 15.11+20171207~git445

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -116,6 +116,12 @@
   #set(BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin)
   set(BIN_INSTALL_DIR ${CMAKE_INSTALL_FULL_BINDIR})
 endif(NOT DEFINED BIN_INSTALL_DIR)
+
+# Where to install system executables
+if(NOT DEFINED SBIN_INSTALL_DIR)
+  #set(BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin)
+  set(SBIN_INSTALL_DIR ${CMAKE_INSTALL_FULL_SBINDIR})
+endif(NOT DEFINED SBIN_INSTALL_DIR)
 
 # Where to install manual pages
 if(NOT DEFINED MAN_INSTALL_DIR)
@@ -299,7 +305,6 @@
   ")
 endfunction(install_if_not_exists)
 
-
 ##############################################################################
 # Main execution starts here
 ##############################################################################
@@ -320,13 +325,3 @@
 set(LIBS ${LIBS} ${SIGC2_LIBRARIES})
 
 # Find the chown utility
-include(FindCHOWN)
-
-# Add directories to build
-add_subdirectory(async)
-add_subdirectory(misc)
-add_subdirectory(echolib)
-add_subdirectory(locationinfo)
-add_subdirectory(svxlink)
-if(USE_QT)
-  add_subdirectory(qtel)

=== src/async/CMakeLists.txt ===
add_subdirectory(core)
add_subdirectory(cpp)
add_subdirectory(audio)
if(USE_QT)
  add_subdirectory(qt)
endif(USE_QT)
add_subdirectory(demo)

=== src/qtel/translations/CMakeLists.txt ===
# Language translations
set(TRANSLATIONS
  qtel_sv.ts qtel_de.ts qtel_tr.ts qtel_nl.ts qtel_it.ts qtel_uk.ts qtel_ru.ts
  qtel_hu.ts qtel_ja.ts qtel_fr.ts qtel_es.ts
  )

if (Qt5Core_FOUND)
  find_package(Qt5LinguistTools REQUIRED)
  QT5_ADD_TRANSLATION(TRANSLATIONS_QM ${TRANSLATIONS})
elseif (QT4_FOUND)
  QT4_ADD_TRANSLATION(TRANSLATIONS_QM ${TRANSLATIONS})
else()
  message(FATAL_ERROR "Neither Qt4 nor Qt5 translation tools are present")
endif()

add_custom_target(translations ALL DEPENDS ${TRANSLATIONS_QM})

=== src/svxlink/systemd/CMakeLists.txt ===
#############################################################################
# SvxLink ROIP Repeater system Systemd setup
#############################################################################

set(SYSTEMD_CONFIGURATIONS_FILES_DIR "/lib/systemd/system" CACHE PATH
  "Path to systemd units")
set(SYSTEMD_DEFAULTS_FILES_DIR "/etc/default" CACHE PATH
  "Path to systemd unit configuration files")
set(SYSTEMD_SOURCE_DIR "${CMAKE_SOURCE_DIR}/svxlink/systemd")

configure_file(${SYSTEMD_SOURCE_DIR}/svxlink_gpio_setup.service.in
               ${PROJECT_BINARY_DIR}/systemd/svxlink_gpio_setup.service)
#message(STATUS "Configured systemd unit file:svxlink_gpio_setup.service")

configure_file(${SYSTEMD_SOURCE_DIR}/svxlink.service.in
               ${PROJECT_BINARY_DIR}/systemd/svxlink.service)
#message(STATUS "Configured systemd unit file:svxlink.service")

configure_file(${SYSTEMD_SOURCE_DIR}/remotetrx.service.in
               ${PROJECT_BINARY_DIR}/systemd/remotetrx.service)
#message(STATUS "Configured systemd unit file:remotetrx.service")

configure_file(${SYSTEMD_SOURCE_DIR}/svxlink.default.in
               ${PROJECT_BINARY_DIR}/systemd/svxlink)
#message(STATUS "Configured systemd unit file:svxlink")

configure_file(${SYSTEMD_SOURCE_DIR}/remotetrx.default.in
               ${PROJECT_BINARY_DIR}/systemd/remotetrx)
#message(STATUS "Configured systemd unit file:remotetrx")

install(FILES ${PROJECT_BINARY_DIR}/systemd/svxlink_gpio_setup.service
        DESTINATION ${SYSTEMD_CONFIGURATIONS_FILES_DIR})
install(FILES ${PROJECT_BINARY_DIR}/systemd/svxlink.service
        DESTINATION ${SYSTEMD_CONFIGURATIONS_FILES_DIR})
install(FILES ${PROJECT_BINARY_DIR}/systemd/remotetrx.service
        DESTINATION ${SYSTEMD_CONFIGURATIONS_FILES_DIR})
message(STATUS "Systemd unit files will be installed to "
        "${SYSTEMD_CONFIGURATIONS_FILES_DIR} after make install")

install(FILES ${PROJECT_BINARY_DIR}/systemd/svxlink
        DESTINATION ${SYSTEMD_DEFAULTS_FILES_DIR} )
install(FILES ${PROJECT_BINARY_DIR}/systemd/remotetrx
        DESTINATION ${SYSTEMD_DEFAULTS_FILES_DIR} )
message(STATUS "Systemd unit configuration files will be "
               "installed to ${SYSTEMD_DEFAULTS_FILES_DIR} "
               "after make install")

=== src/svxlink/modules/template/CMakeLists.txt ===
# The name of the module without the Module prefix
set(MODNAME Template)

# Module source code
#set(MODSRC xyz.cpp)

# Project libraries to link to
#set(LIBS ${LIBS} echolib)

# The version tag name without the VER_ prefix
set(VERNAME ${MODNAME})
string(REGEX REPLACE \(.\)\([A-Z]\) \\1_\\2 VERNAME ${VERNAME})
string(TOUPPER MODULE_${VERNAME} VERNAME)

# Add targets for version files
set(VERSION_DEPENDS)
add_version_target(${VERNAME} VERSION_DEPENDS)
add_version_target(SVXLINK VERSION_DEPENDS)

# Build the plugin
add_library(Module${MODNAME} MODULE Module${MODNAME}.cpp ${MODSRC}
  ${VERSION_DEPENDS}
)
set_target_properties(Module${MODNAME} PROPERTIES PREFIX "")
set_property(TARGET Module${MODNAME} PROPERTY NO_SONAME 1)
target_link_libraries(Module${MODNAME} ${LIBS})

# Install targets
install(TARGETS Module${MODNAME} DESTINATION ${SVX_MODULE_INSTALL_DIR})
install(FILES ${MODNAME}.tcl DESTINATION ${SVX_SHARE_INSTALL_DIR}/events.d)
install_if_not_exists(Module${MODNAME}.conf
  ${SVX_SYSCONF_INSTALL_DIR}/svxlink.d
  )
